Skip to content

Latest commit

 

History

History
 
 

334. Increasing Triplet Subsequence

Folders and files

NameName
Last commit message
Last commit date

parent directory

..
 
 

Given an integer array nums, return true if there exists a triple of indices (i, j, k) such that i < j < k and nums[i] < nums[j] < nums[k]. If no such indices exists, return false.

 

Example 1:

Input: nums = [1,2,3,4,5]
Output: true
Explanation: Any triplet where i < j < k is valid.

Example 2:

Input: nums = [5,4,3,2,1]
Output: false
Explanation: No triplet exists.

Example 3:

Input: nums = [2,1,5,0,4,6]
Output: true
Explanation: The triplet (3, 4, 5) is valid because nums[3] == 0 < nums[4] == 4 < nums[5] == 6.

 

Constraints:

  • 1 <= nums.length <= 5 * 105
  • -231 <= nums[i] <= 231 - 1

 

Follow up: Could you implement a solution that runs in O(n) time complexity and O(1) space complexity?

Companies:
Google, Facebook, Amazon

Related Topics:
Array, Greedy

Similar Questions:

Solution 1. Longest Increasing Subsequence

This is a simplified version of 300. Longest Increasing Subsequence (Medium).

It's a regret greedy algorithm. We maintain a mono-increasing subsequence. For each A[i], we use it to replace the first number in the subsequence that is >= A[i].

It's simplified compared to LIS because we only need to keep a subsequence of length 3.

// OJ: https://leetcode.com/problems/increasing-triplet-subsequence/
// Author: github.com/lzl124631x
// Time: O(N)
// Space: O(1)
class Solution {
public:
    bool increasingTriplet(vector<int>& A) {
        int first = INT_MAX, second = INT_MAX;
        for (int n : A) {
            if (n <= first) first = n;
            else if (n <= second) second = n;
            else return true;
        }
        return false;
    }
};